<?php

/**
 * 
 *
 * 
 *
 */

class MuDB_Db extends Zend_Db
{
	protected $_config = null;
	protected $_default_slave = null;
	protected $_default_master = null;
	protected $_read_key = null;
	protected $_write_key = null;
	protected $_dbm = null;
	protected $_dbs = null;
	protected $_db_total = null;
	public static $_init_db = false;
	private static $_Model = null;
	public static $_MuDB = null;
	protected function __construct($config){
		if ($config instanceof Zend_Config) {
            $config = $config->toArray();
        }
		if (!isset($config["model"])){
			throw new Exception('error!! MuDB_Db config model not found');
		}elseif(($config["model"] !='Rw')&&($config["model"] !='Mw')){
			throw new Exception('erroe!! MuDB_Db model just can be "Rw" or "Mw"');
		}elseif(!isset($config["master"])){
			throw new Exception('erroe!! MuDB_Db need master at least');	
		}
		
		if (is_array($config["master"])){
			foreach ($config["master"] as $key){
				if (!isset($config["db"][$key]))
					throw new Exception('erroe!! MuDB_Db master "'.$key.'" not found in db');
			}
		}else{
			if(!isset($config["db"])){
				throw new Exception('erroe!! MuDB_Db need db at least');				
			}elseif((is_array($config["db"]))&&(!isset($config["db"][$config["master"]]))){
				throw new Exception('erroe!! MuDB_Db master not found in db');
			}
		}
		$this->_config = $config;
		if ($config["model"] == 'Rw'){
			$this->_Rw_init();
		}else{
			$this->_Mw_init();
		}
		$this->_Model = $config["model"];
		$this->_db_total = (($this->_dbm != null) ? count($this->_dbm):0) + (($this->_dbs != null) ? count($this->_dbs):0);
		return $this->_default_master;
	}
	public function get_db(){
		if (self::$_init_db){
			return $this->_default_master;
		}
	}
	protected function _Mw_init(){
		if (is_array($this->_config["master"])){
			foreach ($this->_config["master"] as $key){
				if (!isset($this->_config["db"][$key]))
					throw new Exception('erroe!! MuDB_Db master "'.$key.'" not found in db');
			}
			foreach ($this->_config["master"] as $master) {
	        	$adapter = $this->_config["db"][$master]['adapter'];
	            $default = isset($this->_config["db"][$master]['default'])?(int)$this->_config["db"][$master]['default']:false;
	            unset($this->_config["db"][$master]['adapter'], $this->_config["db"][$master]['default']);
	            $this->_dbm[$master] = new Mudb_Db_Adapter_Mw($adapter, $this->_config["db"][$master],$master);

	            if ($default
	                // For consistency with the Db Resource Plugin
	                || (isset($this->_config["db"][$master]['isDefaultTableAdapter']) 
	                    && $this->_config["db"][$master]['isDefaultTableAdapter'] == true)
	            ) {
	                $this->_default_master = $this->_dbm[$master];
	            }
	        }
			self::$_init_db = true;
		}else{
			$adapter = $this->_config["db"]['adapter'];
            $this->_dbm[$this->_config["master"]] = new Mudb_Db_Adapter_Mw($adapter, $this->_config["db"],$this->_config["master"]);
            $this->_default_master = $this->_dbm[$this->_config["master"]];
			self::$_init_db = true;
		}
	}
	protected function _Rw_init(){
		if ((isset($this->_config['slave']))&&(is_array($this->_config["slave"]))){
			foreach ($this->_config["slave"] as $key){
				if (!isset($this->_config["db"][$key])){
					throw new Exception('erroe!! MuDB_Db slave "'.$key.'" not found in db');
				}elseif($this->_config["master"] == $key){
					
				}elseif(is_array($this->_config["master"])){
					foreach ($this->_config["master"] as $key2){
						if ($key2 == $key)
							throw new Exception('erroe!! MuDB_Db master "'.$key.'" duplication slave "'.$key.'"!!');
					}
				}
			}
		}
		$adapter_chk=null;
		foreach ($this->_config["db"] as $key => $params){
			if ($adapter_chk==null) $adapter_chk = $params["adapter"];
			if ($params["adapter"] != $adapter_chk)
				throw new Exception('erroe!! MuDB_Db "'.$key.'" not same as another db adapter');
		}
		foreach ($this->_config["slave"] as $slave) {
        	$adapter = $this->_config["db"][$slave]['adapter'];
            $default = isset($this->_config["db"][$slave]['default'])?(int)$this->_config["db"][$slave]['default']:false;
            unset($this->_config["db"][$slave]['adapter'], $this->_config["db"][$slave]['default']);
            $this->_dbs[$slave] = new Mudb_Db_Adapter_Rw($adapter, $this->_config["db"][$slave],$slave);

            if ($default
                // For consistency with the Db Resource Plugin
                || (isset($this->_config["db"][$slave]['isDefaultTableAdapter']) 
                    && $this->_config["db"][$slave]['isDefaultTableAdapter'] == true)
            ) {
                $this->_default_slave = $this->_dbs[$slave];
            }
        }
		$this->_Master_init();
	}
	protected function _Master_init(){
		if (is_array($this->_config["master"])){
			foreach ($this->_config["master"] as $key){
				if (!isset($this->_config["db"][$key]))
					throw new Exception('erroe!! MuDB_Db master "'.$key.'" not found in db');
			}
			foreach ($this->_config["master"] as $master) {
	        	$adapter = $this->_config["db"][$master]['adapter'];
	            $default = isset($this->_config["db"][$master]['default'])?(int)$this->_config["db"][$master]['default']:false;
	            unset($this->_config["db"][$master]['adapter'], $this->_config["db"][$master]['default']);
	            $this->_dbm[$master] = new Mudb_Db_Adapter_Rw($adapter, $this->_config["db"][$master],$master);

	            if ($default
	                // For consistency with the Db Resource Plugin
	                || (isset($this->_config["db"][$master]['isDefaultTableAdapter']) 
	                    && $this->_config["db"][$master]['isDefaultTableAdapter'] == true)
	            ) {
	                $this->_default_master = $this->_dbm[$master];
	            }
	        }
			$this->_default_master = $this->_dbm[$master];
			self::$_init_db = true;
		}else{
			$adapter = $this->_config["db"]['adapter'];
            $this->_dbm[$this->_config["master"]] = new Mudb_Db_Adapter_Rw($adapter, $this->_config["db"],$this->_config["master"]);
            $this->_default_master = $this->_dbm[$this->_config["master"]];
			self::$_init_db = true;
		}
	}
	protected function _get_all_db(){
		return array_merge($this->_dbm , $this->_dbs);
	}
	public static function getInstance($config){
		self::$_MuDB = new MuDB_Db($config);
		return self::$_MuDB->get_db();
	}
	public static function getAllDb(){
		if (self::$_MuDB != null){
			return self::$_MuDB->_get_all_db();
		}else{
			return false;
		}
	}
	protected function _get_Db_write_db_select(){
		$db = $this->_dbm;
		if ($this->_write_key == null){
			$this->_write_key = $db;
		}
		$active_db = array_shift($this->_write_key);
		array_push($this->_write_key, $active_db);
		return $active_db;
	}
	protected function _get_Db_write_delete($table, $where = ''){
		foreach ($this->_dbm as $db){
			$result = $db->MU_DB_delete($table, $where);
		}
		return $result;
	}
	public static function Db_write_delete($table, $where = ''){
		if (self::$_MuDB != null){
			return self::$_MuDB->_get_Db_write_delete($table, $where);
		}
	}
	protected function _get_Db_write_update($table, array $bind, $where = ''){
		foreach ($this->_dbm as $db){
			$result = $db->MU_DB_update($table,$bind, $where);
		}
		return $result;
	}
	public static function Db_write_update($table, array $bind, $where = ''){
		if (self::$_MuDB != null){
			return self::$_MuDB->_get_Db_write_update($table,$bind, $where);
		}
	}
	protected function _get_Db_write_insert($table, array $bind){
		foreach ($this->_dbm as $db){
			$result = $db->MU_DB_insert($table, $bind);
		}
		return $result;
	}
	public static function Db_write_insert($table, array $bind){
		if (self::$_MuDB != null){
			return self::$_MuDB->_get_Db_write_insert($table, $bind);
		}
	}
	protected function _get_Db_read_db_select(){
		$db = ($this->_dbs != null) ? $this->_dbs :$this->_dbm;
		if ($this->_read_key == null){
			$this->_read_key = $db;
		}
		$active_db = array_shift($this->_read_key);
		array_push($this->_read_key, $active_db);
		return $active_db;
	}
	protected function _get_Db_select_array($functions,$sql, $bind = array(), $fetchMode = null){
		return ($this->_Model == 'Rw') ? $this->_get_Db_read_db_select()->MU_DB_array($functions,$sql, $bind, $fetchMode):
										 $this->_get_Db_write_db_select()->MU_DB_array($functions,$sql, $bind, $fetchMode);
	}
	public static function Db_select_array($functions,$sql, $bind, $fetchMode){
		if (self::$_MuDB != null){
			return self::$_MuDB->_get_Db_select_array($functions,$sql, $bind, $fetchMode);
		}
	}
	protected function _get_Db_select_item($functions,$sql, $bind = array()){
		return ($this->_Model == 'Rw') ? $this->_get_Db_read_db_select()->MU_DB_item($functions,$sql, $bind):
										 $this->_get_Db_write_db_select()->MU_DB_item($functions,$sql, $bind);
	}
	public static function Db_select_item($functions,$sql, $bind = array()){
		if (self::$_MuDB != null){
			return self::$_MuDB->_get_Db_select_item($functions,$sql, $bind);
		}
	}
    public static function factory($adapter, $config = array())
    {
        if ($config instanceof Zend_Config) {
            $config = $config->toArray();
        }

        if ($adapter instanceof Zend_Config) {
            if (isset($adapter->params)) {
                $config = $adapter->params->toArray();
            }
            if (isset($adapter->adapter)) {
                $adapter = (string) $adapter->adapter;
            } else {
                $adapter = null;
            }
        }
		/*
         * Verify that adapter parameters are in an array.
         */
        if (!is_array($config)) {
            /**
             * @see Zend_Db_Exception
             */
            require_once 'Zend/Db/Exception.php';
            throw new Zend_Db_Exception('Adapter parameters must be in an array or a Zend_Config object');
        }
		/*
         * Verify that an adapter name has been specified.
         */
        if (!is_string($adapter) || empty($adapter)) {
            /**
             * @see Zend_Db_Exception
             */
            require_once 'Zend/Db/Exception.php';
            throw new Zend_Db_Exception('Adapter name must be specified in a string');
        }
		self::getInstance($config);
    }

}
